<template lang="pug">
transition(@enter="onEnter" @leave="onLeave" :css='false' mode="out-in")
  slot(v-if="!loading")
  slot(v-else name="loader")
    .abs-top-center.text-center(key='loader' ref="loader")
      .fa.fa-spinner.fa-pulse
</template>
<script setup>
// @ts-check

import { computed, defineEmits, defineProps, ref, useSlots } from "vue";
import { first } from "@cern/nodash";
import Anim from "./BaseAnimation.js";

/**
 * @typedef {import('vue').VNode} VNode
 * @typedef {import('vue').ComponentPublicInstance} ComponentPublicInstance
 * @typedef {import('./BaseAnimation.js').Anim} AnimType
 * @typedef {import('./BaseAnimation.js').AnimOptions} AnimOptions
 */

const props = defineProps({
  loading: Boolean,
  anim: {
    type: /** @type {V.PropType<keyof Anim>} */ (String),
    default: Anim.default
  }
});

const emit = defineEmits([ "onEnter", "onLeave" ]);

const slots = useSlots();

const loader = ref(null);

const animation = computed(
  () => /** @type {AnimType} */ (Anim[/** @type {keyof Anim} */ (props.anim)] ?? {}));

/**
 * @param {VNode|ComponentPublicInstance|Element} elt
 * @param {function} done
 */
function onEnter(elt, done) {
  if (elt && (elt === first(slots.loader) || elt === loader.value)) {
    Anim.fade.in?.(elt, null, done);
  }
  else if (animation.value?.in) {
    animation.value.in(elt, null, done);
  }
  else {
    done();
  }
}

/**
 * @param {VNode|ComponentPublicInstance|Element} elt
 * @param {function} done
 */
function onLeave(elt, done) {
  if (elt && (elt === first(slots.loader) || elt === loader.value)) {
    Anim.fade.out?.(elt, null, done);
  }
  else if (animation.value?.out) {
    animation.value.out(elt, null, done);
  }
  else {
    done();
  }
}

</script>
